package services

import (
	"errors"
	"hongze/hongze_cygx/models"
	"hongze/hongze_cygx/utils"
	"time"
)

func SpecialTripPopupMsg(activityInfo *models.CygxActivitySpecialDetail, user *models.WxUserItem) (signupStatus int, popupMsg, popupMsg2 string, err error) {
	//SignupStatus  int    `description:"返回状态：1：成功 、2 ：人数已满 、3：调研次数已用完、 4：超时"`
	signupStatus = 1
	resultTime := utils.StrTimeToTime(activityInfo.ActivityTime) //时间字符串格式转时间格式
	if time.Now().After(resultTime.Add(-time.Minute * 60)) {
		signupStatus = 4
		popupMsg = "活动开始前1小时内无法报名，请联系对口销售处理"
		return
	}
	var condition string
	var pars []interface{}

	condition += ` AND activity_id LIKE ? `
	pars = append(pars, activityInfo.ActivityId)

	tripTota, e := models.GetActivitySpecialTripCountByActivityId(condition, pars)
	if e != nil {
		err = errors.New("GetCygxActivitySpecialDetailList, Err: " + e.Error())
		return
	}
	if activityInfo.LimitPeopleNum-tripTota < 1 {
		signupStatus = 2
		popupMsg = "此活动报名人数已满，请留意下期活动"
		return
	}
	//signupStatus = 4
	popupMsg = "感谢参与，本次报名会扣除一次贵司在弘则的调研点数。"
	popupMsg2 = "由于每场活动人数有限，如果不能参加请提前48小时取消，未及时取消导致影响其他客户报名将会维持扣点。"
	return
}
